#*******************************************************************************
#* Usage:
#*
#*	ruby extconf.rb --with-p4api-include=<path to api> \
#*			--with-p4api-lib=<path to api>
#*
#*******************************************************************************
require 'mkmf'
require 'rbconfig'
# Work out the target OS, to guess the right defines to pass to the 
# Perforce API
arch = RUBY_PLATFORM.dup
arch.gsub!( /.*-(.*)(-.*)?/, '\1' )
arch.gsub!( /(\d+\.?)*/, "" )
arch.upcase!
arch.gsub!( /MSWIN/, "NT" )
puts( "I think you're running on #{arch}" )

$CFLAGS += "-DOS_#{arch} "

if ( arch == "NT" )
  $CFLAGS += "/DCASE_INSENSITIVE "
  $CFLAGS += "/MT "
end

dir_config( 'p4api' )

# Libraries in reverse order because of the way mkmf handles them
if ( arch == "SOLARIS" )
  osver = `uname -r`
  osver.gsub!( /5\./, "2" )
  if ( osver == "25" )
    $CFLAGS += "-DSOLARIS25 "
    $LDFLAGS += "/usr/ucblib/libucb.a "
  else
    $CFLAGS += "-DSOLARIS#{osver} "
  end
  $CFLAGS += "-Dsolaris "
  have_library( "nsl", "" )
  have_library( "socket", "" )
elsif ( arch == "FREEBSD" )
  have_library( "gcc", "___builtin_new" )
elsif ( arch == "NT" )
  have_library( "advapi32", "" )
  have_library( "wsock32", "" )
  have_library( "kernel32", "" )
  have_library( "oldnames", "" )
  have_library( "libcmt", "" )
end

supplib = "supp"
rpclib = "rpc"
clientlib = "client"

# NT requires the lib prefix
if ( arch == "NT" )
  supplib = "libsupp"
  rpclib = "librpc"
  clientlib = "libclient"
end

# Perforce API libraries  
have_library( supplib, "" )
have_library( rpclib, "" )
have_library( clientlib, "" )
create_makefile( "P4api" )
